// { dg-do assemble }
// { dg-options "" }

extern "C" void qsort(void *base, __SIZE_TYPE__ nmemb, __SIZE_TYPE__ size,
              int (*compar)(const void *, const void *));

struct R {
  int count;
  int state1;
  int state2;
};

int cmp_d(const R* a, const R* b) {
  return a->count > b->count;
}

namespace CXX {
  template<class T, int i1, int i2>
    inline void qsort (T b[i1][i2], int (*cmp)(const T*, const T*)) {
    ::qsort ((void*)b, i1*i2, sizeof(T), (int (*)(const void *, const void *))cmp);
  }
}

using namespace CXX;

#if __INT_MAX__ >= 2147483647
/* At least 32-bit integers.  */
#define SIZE 256
#else
#define SIZE 16
#endif

void sort_machine() {
  struct R d[SIZE][SIZE];
  qsort<R,SIZE> (d, cmp_d);
}
